routes/web.php
<?php
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\JoueurController;
use App\Http\Controllers\EquipeController;
use App\Http\Controllers\FiltrageController;

Route::get('/', function () {
    return view('welcome');
})->name('welcome');

// Routes des joueurs
Route::resource('joueurs', JoueurController::class);

// Routes des équipes
Route::resource('equipes', EquipeController::class);

// Route de filtrage
Route::get('/filtrage', [FiltrageController::class, 'filtrer'])->name('filter');

app/Models/Equipe.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Equipe extends Model
{
    protected $fillable = ['nom_equipe', 'nationalite'];

    public function joueurs()
    {
        return $this->hasMany(Joueur::class);
    }
}

app/Models/Joueur.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Joueur extends Model
{
    protected $fillable = ['nom', 'prenom', 'age', 'nationalite', 'equipe_id', 'nombre_buts', 'nombre_trophees'];

    public function equipe()
    {
        return $this->belongsTo(Equipe::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, ValidatesRequests;
}

app/Http/Controllers/EquipeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Equipe;

class EquipeController extends Controller
{
    // Méthode pour afficher la liste des équipes
   public function index()
{
    $equipes = Equipe::all();
    return view('equipes.index', ['equipes' => $equipes]);
}

    // Méthode pour afficher le formulaire de création d'une équipe
    public function create()
    {
        return view('equipes.create');
    }

    // Méthode pour enregistrer une nouvelle équipe
    public function store(Request $request)
    {
        // Validation des données du formulaire
        $request->validate([
            'nom' => 'required|string|max:255',
            'pays' => 'required|string|max:255',
            // Ajoutez d'autres règles de validation au besoin
        ]);

        // Création d'une nouvelle équipe
        Equipe::create($request->all());

        return redirect()->route('equipes.index')->with('success', 'Équipe créée avec succès.');
    }

    // Méthode pour afficher le formulaire de modification d'une équipe
    public function edit($id)
    {
        $equipe = Equipe::findOrFail($id);
        return view('equipes.edit', compact('equipe'));
    }

    // Méthode pour mettre à jour les informations d'une équipe
    public function update(Request $request, $id)
    {
        $request->validate([
            'nom' => 'required|string|max:255',
            'pays' => 'required|string|max:255',
            // Ajoutez d'autres règles de validation au besoin
        ]);

        $equipe = Equipe::findOrFail($id);
        $equipe->update($request->all());

        return redirect()->route('equipes.index')->with('success', 'Équipe mise à jour avec succès.');
    }

    // Méthode pour supprimer une équipe
    public function destroy($id)
    {
        $equipe = Equipe::findOrFail($id);
        $equipe->delete();

        return redirect()->route('equipes.index')->with('success', 'Équipe supprimée avec succès.');
    }
}

app/Http/Controllers/FiltrageController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class FiltrageController extends Controller
{
    public function filtrer(Request $request)
    {
        // Récupérer les données du formulaire de filtrage
        $nom_joueur = $request->input('nom_joueur');
        $prenom_joueur = $request->input('prenom_joueur');
        $nombre_buts = $request->input('nombre_buts');
        $nombre_trophees = $request->input('nombre_trophees');
        $nationalite = $request->input('nationalite');
        $equipe = $request->input('equipe');
        $nombre_buts_equipe = $request->input('nombre_buts_equipe');

        // Filtrer les joueurs et les équipes en fonction des critères de recherche
        $resultats = DB::table('joueurs')
            ->join('equipes', 'joueurs.equipe_id', '=', 'equipes.id')
            ->select('joueurs.*', 'equipes.nom_equipe')
            ->when($nom_joueur, function ($query) use ($nom_joueur) {
                return $query->where('joueurs.nom', 'like', "%$nom_joueur%");
            })
            ->when($prenom_joueur, function ($query) use ($prenom_joueur) {
                return $query->where('joueurs.prenom', 'like', "%$prenom_joueur%");
            })
            ->when($nombre_buts, function ($query) use ($nombre_buts) {
                return $query->where('joueurs.nombre_buts', $nombre_buts);
            })
            ->when($nombre_trophees, function ($query) use ($nombre_trophees) {
                return $query->where('joueurs.nombre_trophees', $nombre_trophees);
            })
            ->when($nationalite, function ($query) use ($nationalite) {
                return $query->where('joueurs.nationalite', 'like', "%$nationalite%");
            })
            ->when($equipe, function ($query) use ($equipe) {
                return $query->where('equipes.nom_equipe', 'like', "%$equipe%");
            })
            ->when($nombre_buts_equipe, function ($query) use ($nombre_buts_equipe) {
                return $query->groupBy('equipes.id')
                    ->havingRaw('SUM(joueurs.nombre_buts) >= ?', [$nombre_buts_equipe]);
            })
            ->get();

        // Retourner la vue avec les résultats de la recherche
        return view('filtrage', compact('resultats'));
    }
}

app/Http/Controllers/JoueurController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Joueur;
use App\Models\Equipe;


class JoueurController extends Controller
{
    public function index()
    {
        $joueurs = Joueur::all();
        return view('joueurs.index', compact('joueurs'));
    }

    public function create()
{
    $equipes = Equipe::all();
    return view('joueurs.create', compact('equipes'));
}


    public function store(Request $request)
    {
        $request->validate([
            'nom' => 'required',
            'prenom' => 'required',
            'age' => 'required|integer',
            'nationalite' => 'required',
            'nombre_buts' => 'nullable|integer',
            'nombre_trophees' => 'nullable|integer'
        ]);

        Joueur::create($request->all());

        return redirect()->route('joueurs.index')->with('success', 'Joueur ajouté avec succès.');
    }


    public function update(Request $request, $id)
    {
        $request->validate([
            'nom' => 'required',
            'prenom' => 'required',
            'age' => 'required|integer',
            'nationalite' => 'required',
            'nombre_buts' => 'nullable|integer',
            'nombre_trophees' => 'nullable|integer'
        ]);

        $joueur = Joueur::findOrFail($id);
        $joueur->update($request->all());

        return redirect()->route('joueurs.index')->with('success', 'Joueur mis à jour avec succès.');
    }

    public function destroy($id)
    {
        $joueur = Joueur::findOrFail($id);
        $joueur->delete();

        return redirect()->route('joueurs.index')->with('success', 'Joueur supprimé avec succès.');
    }
    public function show($id)
{
    $joueur = Joueur::findOrFail($id);
    return view('joueurs.show', compact('joueur'));
}
public function edit($id)
{
    $joueur = Joueur::findOrFail($id);
    $equipes = Equipe::all(); // Assurez-vous d'importer le modèle Equipe
    return view('joueurs.edit', compact('joueur', 'equipes'));
}

}

resources/views/equipes/create.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Ajouter une équipe</title>
</head>
<body>
    <h1>Ajouter une équipe</h1>

    @if ($errors->any())
        <div>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    <form action="{{ route('equipes.store') }}" method="POST">
        @csrf
        <div>
            <label for="nom_equipe">Nom de l'équipe:</label>
            <input type="text" id="nom_equipe" name="nom_equipe" required>
        </div>
        <div>
            <label for="nationalite">Nationalité:</label>
            <input type="text" id="nationalite" name="nationalite" required>
        </div>
        <button type="submit">Ajouter Équipe</button>
    </form>
</body>
</html>

resources/views/equipes/edit.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Modifier une équipe</title>
</head>
<body>
    <h1>Modifier une équipe</h1>

    @if ($errors->any())
        <div>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    <form action="{{ route('equipes.update', $equipe->id) }}" method="POST">
        @csrf
        @method('PUT')
        <div>
            <label for="nom_equipe">Nom de l'équipe:</label>
            <input type="text" id="nom_equipe" name="nom_equipe" value="{{ $equipe->nom_equipe }}" required>
        </div>
        <div>
            <label for="nationalite">Nationalité:</label>
            <input type="text" id="nationalite" name="nationalite" value="{{ $equipe->nationalite }}" required>
        </div>
        <button type="submit">Enregistrer les modifications</button>
    </form>
</body>
</html>

resources/views/equipes/index.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Liste des équipes</title>
</head>
<body>
    <h1>Liste des équipes</h1>

    <ul>
        @foreach ($equipes as $equipe)
            <li>
                {{ $equipe->nom_equipe }} - {{ $equipe->nationalite }}
                <form action="{{ route('equipes.destroy', $equipe->id) }}" method="POST">
                    @csrf
                    @method('DELETE')
                    <button type="submit">Supprimer</button>
                </form>
                <a href="{{ route('equipes.edit', $equipe->id) }}">Modifier</a>
            </li>
        @endforeach
    </ul>

    <a href="{{ route('equipes.create') }}">Ajouter une équipe</a>
</body>
</html>

resources/views/filtrage.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Résultats de la recherche</title>
</head>
<body>
    <h1>Résultats de la recherche</h1>

    @if ($resultats->isEmpty())
        <p>Aucun résultat trouvé.</p>
    @else
        <ul>
            @foreach ($resultats as $resultat)
                <li>{{ $resultat->nom }} {{ $resultat->prenom }} - Équipe: {{ $resultat->nom_equipe }} - Buts: {{ $resultat->nombre_buts }} - Trophées: {{ $resultat->nombre_trophees }}</li>
            @endforeach
        </ul>
    @endif
</body>
</html>

resources/views/joueurs/create.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Ajouter un joueur</title>
</head>
<body>
    <h1>Ajouter un joueur</h1>

    @if ($errors->any())
        <div>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    <form action="{{ route('joueurs.store') }}" method="POST">
        @csrf
        <div>
            <label for="nom">Nom:</label>
            <input type="text" id="nom" name="nom" required>
        </div>
        <div>
            <label for="prenom">Prénom:</label>
            <input type="text" id="prenom" name="prenom" required>
        </div>
        <div>
            <label for="age">Âge:</label>
            <input type="number" id="age" name="age" required>
        </div>
        <div>
            <label for="nationalite">Nationalité:</label>
            <input type="text" id="nationalite" name="nationalite" required>
        </div>
        <div>
            <label for="equipe_id">Équipe:</label>
            <select id="equipe_id" name="equipe_id" required>
                @foreach($equipes as $equipe)
                    <option value="{{ $equipe->id }}">{{ $equipe->nom_equipe }}</option>
                @endforeach
            </select>
        </div>
        <div>
            <label for="nombre_buts">Nombre de buts marqués:</label>
            <input type="number" id="nombre_buts" name="nombre_buts" min="0">
        </div>
        <div>
            <label for="nombre_trophees">Nombre de trophées gagnés:</label>
            <input type="number" id="nombre_trophees" name="nombre_trophees" min="0">
        </div>
        <button type="submit">Ajouter Joueur</button>
    </form>
</body>
</html>

resources/views/joueurs/edit.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Modifier un joueur</title>
</head>
<body>
    <h1>Modifier un joueur</h1>

    @if ($errors->any())
        <div>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    <form action="{{ route('joueurs.update', $joueur->id) }}" method="POST">
        @csrf
        @method('PUT')
        <div>
            <label for="nom">Nom:</label>
            <input type="text" id="nom" name="nom" value="{{ $joueur->nom }}" required>
        </div>
        <div>
            <label for="prenom">Prénom:</label>
            <input type="text" id="prenom" name="prenom" value="{{ $joueur->prenom }}" required>
        </div>
        <div>
            <label for="age">Âge:</label>
            <input type="number" id="age" name="age" value="{{ $joueur->age }}" required>
        </div>
        <div>
            <label for="nationalite">Nationalité:</label>
            <input type="text" id="nationalite" name="nationalite" value="{{ $joueur->nationalite }}" required>
        </div>
        <div>
            <label for="equipe_id">Équipe:</label>
            <select id="equipe_id" name="equipe_id" required>
                @foreach($equipes as $equipe)
                    <option value="{{ $equipe->id }}" {{ $joueur->equipe_id == $equipe->id ? 'selected' : '' }}>{{ $equipe->nom_equipe }}</option>
                @endforeach
            </select>
        </div>
        <div>
            <label for="nombre_buts">Nombre de buts marqués:</label>
            <input type="number" id="nombre_buts" name="nombre_buts" value="{{ $joueur->nombre_buts }}" min="0">
        </div>
        <div>
            <label for="nombre_trophees">Nombre de trophées gagnés:</label>
            <input type="number" id="nombre_trophees" name="nombre_trophees" value="{{ $joueur->nombre_trophees }}" min="0">
        </div>
        <button type="submit">Enregistrer les modifications</button>
    </form>
</body>
</html>

resources/views/joueurs/index.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Liste des joueurs</title>
</head>
<body>
    <h1>Liste des joueurs</h1>
    <a href="{{ route('joueurs.create') }}">Ajouter un joueur</a>
    <ul>
        @foreach ($joueurs as $joueur)
            <li>
                {{ $joueur->nom }} {{ $joueur->prenom }}
                <form action="{{ route('joueurs.destroy', $joueur->id) }}" method="POST">
                    @csrf
                    @method('DELETE')
                    <button type="submit">Supprimer</button>
                </form>
                <a href="{{ route('joueurs.edit', $joueur->id) }}">Modifier</a>
                <a href="{{ route('joueurs.show', $joueur->id) }}">Détails</a>
            </li>
        @endforeach
    </ul>

    
</body>
</html>

resources/views/joueurs/show.blade.php
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Détails du joueur</title>
</head>
<body>
    <h1>Détails du joueur</h1>

    <p><strong>Nom:</strong> {{ $joueur->nom }}</p>
    <p><strong>Prénom:</strong> {{ $joueur->prenom }}</p>
    <p><strong>Âge:</strong> {{ $joueur->age }}</p>
    <p><strong>Nationalité:</strong> {{ $joueur->nationalite }}</p>
    <p><strong>Équipe:</strong> {{ $joueur->equipe ? $joueur->equipe->nom_equipe : 'Non assignée' }}</p>
    <p><strong>Nombre de buts marqués:</strong> {{ $joueur->nombre_buts }}</p>
    <p><strong>Nombre de trophées gagnés:</strong> {{ $joueur->nombre_trophees }}</p>

    <a href="{{ route('joueurs.index') }}">Retour à la liste des joueurs</a>
</body>
</html>